=== debian/changelog ===
libphysfs (3.0.2-6) unstable; urgency=medium

  * Bump Standards-Version to 4.6.1.
  * Adjust renamed lintian tag name in override.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 14 Sep 2022 14:37:40 +0200

libphysfs (3.0.2-5) unstable; urgency=medium

  * Adjust lintian overrides.
  * Bump Standards-Version to 4.5.1.
  * Bump debhelper-compat to level 13.
  * Update debian/watch file standard to version 4.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 19 Nov 2020 14:58:29 +0100

libphysfs (3.0.2-4) unstable; urgency=medium

  * Bump Standards-Version to 4.5.0.
  * Use the new debhelper-compat notation, and drop the d/compat file.
  * Adjust source lintian-overrides.
  * Set Rules-Requires-Root: no.
  * Add physfs.pc file.
    Closes: #935441
  * Set fixfilepath for reproducible builds.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 23 Jan 2020 16:32:59 +0100

libphysfs (3.0.2-3) unstable; urgency=medium

  * Make a new source only upload.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 23 Jul 2019 11:42:52 +0200

libphysfs (3.0.2-2) unstable; urgency=medium

  * Bump Standards-Version to 4.4.0.
  * Uploading to unstable.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 08 Jul 2019 15:25:16 +0200

libphysfs (3.0.2-1) experimental; urgency=medium

  * New upstream release.
    - Remove merged patch 01-setwritedir.
    - Remvoe merged patch 02-fsync.
  * Acknowledge 3.0.1-3.1 NMU.
  * Bump Standards-Version to 4.3.0.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 28 Dec 2018 10:25:32 +0100
