## libphysfs 3.2.0

=== debian/changelog ===
libphysfs (3.2.0-1) unstable; urgency=medium

  * New upstream release.
    - Add new files.
    - Remove obsolete workarounds from debian/rules.
  * Add patch 01-cmake-version to fix FTBFS with CMake 4.2.
    Closes: #1125547
  * Bump Standards-Version to 4.7.3 (Remove priority field).
  * Remove Rules-Requires-Root control field.
  * Use debian/watch version 5.
  * Fix lintian warning build-depends-on-obsolete-package for libncurses.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 21 Jan 2026 10:38:53 +0100
