=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: libphysfs
 Section: libs
-Priority: optional
 Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
  zlib1g-dev,
- libncurses5-dev,
+ libncurses-dev,
  libreadline-dev
-Standards-Version: 4.6.1
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://www.icculus.org/physfs/
 
 Package: libphysfs-dev
